﻿DKFight = LibStub("AceAddon-3.0"):NewAddon("DKFight", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("DKFight")

-- Spell States
DKFight.spellStates = {
	["Rime"] = false,
	["Killing Machine"] = false,
	["Sudden Doom"] = false,
	["Rune Strike"] = false,
}

-- Spell Cooldown Times
DKFight.spellTimers = {
	["Rime"] = 15,
	["Killing Machine"] = 30,
	["Sudden Doom"] = 15,
}

-- Spell Timer Handles
DKFight.spellTimerHandles = {
	["Rime"] = nil,
	["Killing Machine"] = nil,
	["Sudden Doom"] = nil,
}

-- Spell Textures
DKFight.textures = {
  ["Rime"] = nil,
  ["Killing Machine"] = nil,
  ["Sudden Doom"] = nil,
  ["Rune Strike"] = nil,
}
-- Spell IDs
DKFight.spells = {
	["Icy Touch"] 		= GetSpellInfo(45477),
	["Plague Strike"] 	= GetSpellInfo(45462),
	["Scourge Strike"] 	= GetSpellInfo(55265),
	["Blood Strike"] 	= GetSpellInfo(45902),
	["Death Coil"] 		= GetSpellInfo(52375),
	["Obliterate"] 		= GetSpellInfo(49020),
	["Heart Strike"] 	= GetSpellInfo(55258),
	["Howling Blast"] 	= GetSpellInfo(51408),
	["Frost Strike"] 	= GetSpellInfo(51416),
	--Procs
	["Rime"]			= GetSpellInfo(59052),
	["Killing Machine"]	= GetSpellInfo(51124),
	["Sudden Doom"]		= GetSpellInfo(50466),
	["Rune Strike"] 	= GetSpellInfo(56815),
}
function DKFight:InitOptions()
	self.options = {}
	
	function Options()
		return {
			type = "group",
			name = L["DKFight"],
			handler = DKFight,
			args = {
				-- TABS
				general = {
					type = "group",
					name = L["WTF IS THIS"],
					args = {
						description = {
							type = "description",
							name = L["Helps Death Knights to optimize damage output. Notifies the player when important short duration, commonly overlooked, buffs are applied, and helps the player get into a rotation of abilities to increase DPS."],
							order = 1
						},
						main = {
							type = "group",
							name = L["General Options"],
							inline = true,
							args = {
								show = {
									type = "toggle",
									name = "Show",
									set = "SetShow",
									get = "GetShow",
									order = 1
								},
								locked = {
									type = "toggle",
									name = "Locked",
									set = "SetLocked",
									get = "GetLocked",
									order = 2
								},
								breakMain = {
									type = "header",
									name = "",
									order = 3
								},
								descriptionColor = {
									type = "description",
									name = L["Adjust the default background color and faded background color.  The faded color is used when debuffs are about to expire."],
									order = 7,
								},
								background = {  
									type = "color", 
									name = "Background",
									desc = "Sets the background color of the main frame.",
									get = "GetBackground",
									set = "SetBackground",
									hasAlpha = true,
									order = 8
								},
								faded = { 
									type = "color", 
									name = "Faded",
									desc = "Sets the faded color of the main frame.",
									get = "GetFaded",
									set = "SetFaded",
									hasAlpha = true,
									order = 9
								}
							}
						}
					}	
				},
				detection = {
					type = "group",
					name = L["WTF IS THIS"],
					args = {
						description = {
							type = "description",
							name = L["Set what you want detected, and how it should be displayed."],
							order = 1
						},
						rime = {
							type = "group",
							name = L["Rime"],
							inline = true,
							args = {
								enabled = {
									type = "toggle",
									name = L["Rime procs ..."],
									set = "SetRimeEnabled",
									get = "GetRimeEnabled",
									order = 2
								},
								output = {
									type = "select",
									name = L["output to:"],
									values = { L["Chat Frame"], L["Raid Warning"], L["DK Fight Frame"]},
									set = "SetRimeOutput",
									get = "GetRimeOutput",
									order = 3
								},
							}
						},
						km = {
							type = "group",
							name = L["Killing Machine"],
							inline = true,
							args = {
								enabled = {
									type = "toggle",
									name = L["Killing Machine procs ..."],
									set = "SetKMEnabled",
									get = "GetKMEnabled",
									order = 3
								},
							}
						},
						sd = {
							type = "group",
							name = L["Sudden Doom"],
							inline = true,
							args = {
								enabled = {
									type = "toggle",
									name = L["Sudden Doom procs ..."],
									set = "SetSDEnabled",
									get = "GetSDEnabled",
									order = 4
								},
							}
						},
						rs = {
							type = "group",
							name = L["Rune Strike"],
							inline = true,
							args = {
								enabled = {
									type = "toggle",
									name = L["Rune Strike procs ..."],
									set = "SetRSEnabled",
									get = "GetRSEnabled",
									order = 5
								},
							}
						}
					}
				},
				rotation = {
					type = "group",
					name = L["WTF IS THIS"],
					args = {
						description = {
							type = "description",
							name = L["Empty Stub.  Under Development :)"],
							order = 1
						}
					}
				}
			},
		}
	end
	
	self.options = Options();
	-- Set up options and configuration dialog.
	LibStub("AceConfig-3.0"):RegisterOptionsTable(L["DK Fight"], self.options)
	self.config = {}
	self.config.options = options
	self.config.general = LibStub("AceConfigDialog-3.0"):AddToBlizOptions(L["DK Fight"], nil, nil, 'general')
	self.config.detection = LibStub("AceConfigDialog-3.0"):AddToBlizOptions(L["DK Fight"], L["Detection"], L["DK Fight"], 'detection')
	self.config.rotation = LibStub("AceConfigDialog-3.0"):AddToBlizOptions(L["DK Fight"], L["Rotation"], L["DK Fight"], 'rotation')
	self:RegisterChatCommand("dkfight", "ChatCommand")
	self:RegisterChatCommand("dkf", "ChatCommand")
end

-- Event Handlers
function DKFight:ChatCommand(input)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.config.general)
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(DKFight, "dkp", "DKFight", input)
	end
end

-- MUTATORS / ACCESSORS
function DKFight:SetShow(info, v)
	self.db.profile.show = v;
	self:UpdateVisible();
end

function DKFight:GetShow(info)
	return self.db.profile.show;
end

function DKFight:SetLocked(info, v)
	self.db.profile.locked = v;
	self:UpdateDisplay();
end

function DKFight:GetLocked(info)
	return self.db.profile.locked;
end

function DKFight:SetScale(info, v)
	self.db.profile.scale = v;
	self:UpdateDisplay();
end

function DKFight:GetScale(info)
	return self.db.profile.scale;
end

function DKFight:SetBackground(info, r, g, b, a)
	self.db.profile.colors.background = {r = r, g = g, b = b, a = a}
	self:UpdateDisplay();							
end

function DKFight:GetBackground(info)
	local color = self.db.profile.colors.background
	return color.r, color.g, color.b, color.a								
end

function DKFight:SetFaded(info, r, g, b, a)
	self.db.profile.colors.faded = {r = r, g = g, b = b, a = a}
	self:UpdateDisplay();						
end

function DKFight:GetFaded(info)
	local color = self.db.profile.colors.faded
	return color.r, color.g, color.b, color.a								
end

function DKFight:SetRimeEnabled(info, v)
	self.db.profile.rimeEnabled = v;
end

function DKFight:GetRimeEnabled(info)
	return self.db.profile.rimeEnabled;
end

function DKFight:SetKMEnabled(info, v)
	self.db.profile.kmEnabled = v;
end

function DKFight:GetKMEnabled(info)
	return self.db.profile.kmEnabled;
end

function DKFight:SetSDEnabled(info, v)
	self.db.profile.sdEnabled = v;
end

function DKFight:GetSDEnabled(info)
	return self.db.profile.sdEnabled;
end

function DKFight:SetRSEnabled(info, v)
	self.db.profile.rsEnabled = v;
end

function DKFight:GetRSEnabled(info)
	return self.db.profile.rsEnabled;
end

function DKFight:SetRimeOutput(info, v)
	self.db.profile.rimeOutput = v;
end

function DKFight:GetRimeOutput(info)
	return self.db.profile.rimeOutput;
end