﻿DKFight = LibStub("AceAddon-3.0"):GetAddon("DKFight")
local L = LibStub("AceLocale-3.0"):GetLocale("DKFight")

local defaults = {
	profile = {
		-- Saved Variables
		show = true,
		warn = true,
		locked = false,
		scale = 1.0,
		strata = "BACKGROUND",
		rimeEnabled = true,
		rimeOutput = L["Chat Frame"],
		sdEnabled = true,
		sdOutput = { },
		kmEnabled = true,
		kmOutput = { },
		rsEnabled = true,
		rsOutput = { },
		colors = {
			background = { r = 0.0, g = 0.0, b = 0.0, a = 0.75 },
			warn = { r = 0.75, g = 0.0, b = 0.0, a = 0.75 },
			faded = { r = 0.0, g = 0.0, b = 0.0, a = 0.20 }
		},
		-- Unsaved Variables
		enabled = true,
		x = 0,
		y = 0,
		w = 100,
		h = 50,
		relTo = "CENTER",
		relPt = "CENTER",
		isDKFight = true,
		isDKWarning = false,
		Anchor = nil,
		Display = nil,
		Grip = nil,
		tooltip = "",
		optionsFrame = nil,
		isShowingTooltip = false,
		timeSinceDKFight = 0,
    },
}

function DKFight:OnInitialize()
	-- Load the saved variables.
	self.db = LibStub("AceDB-3.0"):New("DKFightDB", defaults, "Default")
	
	-- Init the options.
	self:InitOptions();
	
	-- Create the display frame for the user.
	self:CreateFrame();
end

function DKFight:OnEnable()
    	-- Called when the addon is enabled
	self:RegisterEvent("UNIT_AURA")
end

function DKFight:OnDisable()
    	-- Called when the addon is disabled
end

-- EVENT HANDLERS
function DKFight:UNIT_AURA()
	-- Check for a "Rime" proc.
	if UnitBuff("player", self.spells["Rime"]) then
		-- Check to make sure the buff is not currently known to be active.
		if not self.spellStates["Rime"] then
			self:Print("Rime!");
			self.spellTimerHandles["Rime"] = self:ScheduleTimer("resetRime", self.spellTimers["Rime"]);
		end
		-- Timer is set, don't come back in here.
		self.spellStates["Rime"] = true;
	else
		-- Something cancelled the buff.
		self:resetRime();
	end
	-- Check for a "Killing Machine" proc.
	if UnitBuff("player", self.spells["Killing Machine"]) then
		-- Check to make sure the buff is not currently known to be active.
		if not self.spellStates["Killing Machine"] then
			self:Print("Killing Machine!");
			self.spellTimerHandles["Killing Machine"] = self:ScheduleTimer("resetKillingMachine", self.spellTimers["Killing Machine"]);
		end
		-- Timer is set, don't come back in here.
		self.spellStates["Killing Machine"] = true;
	else
		-- Something cancelled the buff.
		self:resetKillingMachine();
	end
	-- Check for a "Sudden Doom" proc.
	if UnitBuff("player", self.spells["Sudden Doom"]) then
		-- Check to make sure the buff is not currently known to be active.
		if not self.spellStates["Sudden Doom"] then
			self:Print("Sudden Doom!");
			self.spellTimerHandles["Sudden Doom"] = self:ScheduleTimer("resetSuddenDoom", self.spellTimers["Sudden Doom"]);
		end
		-- Timer is set, don't come back in here.
		self.spellStates["Sudden Doom"] = true;
	else
		-- Something cancelled the buff.
		self:resetSuddenDoom();
	end
end

-- TIMER HANDLERS
function DKFight:resetRime()
	self:CancelTimer(self.spellTimerHandles["Rime"], true);
	self.spellStates["Rime"] = false;
end

function DKFight:resetKillingMachine()
	self:CancelTimer(self.spellTimerHandles["Killing Machine"], true);
	self.spellStates["Killing Machine"] = false;
end

function DKFight:resetSuddenDoom()
	self:CancelTimer(self.spellTimerHandles["Sudden Doom"], true);
	self.spellStates["Sudden Doom"] = false;
end